/*  This file is part of epubgrep.
 *  Copyright © 2021 tastytea <tastytea@tastytea.de>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, version 3.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef EPUBGREP_OUTPUT_HPP
#define EPUBGREP_OUTPUT_HPP

#include "options.hpp"
#include "search.hpp"

#include <vector>

namespace epubgrep::output
{

// Print the matches of an EPUB.
void print_matches(const std::vector<search::match> &matches,
                   const options::options &opts, bool single_file);

//! Print all matches as JSON.
void json_all(const std::vector<std::vector<search::match>> &matches_all);

//! Print all matches as HTML.
void html_all(const std::vector<std::vector<search::match>> &matches_all,
              const options::options &opts);

} // namespace epubgrep::output

#endif // EPUBGREP_OUTPUT_HPP
